"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@ts-ioc/core");
var InjectAnnoBuildStrategyToken = /** @class */ (function (_super) {
    tslib_1.__extends(InjectAnnoBuildStrategyToken, _super);
    function InjectAnnoBuildStrategyToken(type) {
        return _super.call(this, type, 'AnnoBuildStrategy') || this;
    }
    InjectAnnoBuildStrategyToken.classAnnations = { "name": "InjectAnnoBuildStrategyToken", "params": { "constructor": ["type"] } };
    return InjectAnnoBuildStrategyToken;
}(core_1.RefRegistration));
exports.InjectAnnoBuildStrategyToken = InjectAnnoBuildStrategyToken;
/**
 *  base AnnoBuildStrategy Token
 */
exports.AnnoBuildStrategyToken = new InjectAnnoBuildStrategyToken(Object);
/**
 * annotation instance build strategy.
 *
 * @export
 * @class AnnoBuildStrategy
 * @implements {IAnnoBuildStrategy<T>}
 * @template T
 */
var AnnoBuildStrategy = /** @class */ (function () {
    function AnnoBuildStrategy() {
    }
    AnnoBuildStrategy.prototype.build = function (instance, config, options) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!instance) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.beforeInit(instance, config)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.process(instance, config, options)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.afterInit(instance, config)];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * after annotation instance init.
     *
     * @protected
     * @param {BootHooks<T>} instance
     * @param {AnnotationConfigure<T>} config
     * @returns {Promise<void>}
     * @memberof AnnoBuildStrategy
     */
    AnnoBuildStrategy.prototype.beforeInit = function (instance, config) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!core_1.isFunction(instance.anBeforeInit)) return [3 /*break*/, 2];
                        return [4 /*yield*/, instance.anBeforeInit(config)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * build annotation instance process.
     *
     * @protected
     * @param {T} instance
     * @param {AnnotationConfigure<T>} config
     * @param {BuildOptions<T>} [options]
     * @returns {Promise<void>}
     * @memberof AnnoBuildStrategy
     */
    AnnoBuildStrategy.prototype.process = function (instance, config, options) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    /**
     * after annotation instance init.
     *
     * @protected
     * @param {BootHooks<T>} instance
     * @param {AnnotationConfigure<T>} config
     * @returns {Promise<void>}
     * @memberof AnnoBuildStrategy
     */
    AnnoBuildStrategy.prototype.afterInit = function (instance, config) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!core_1.isFunction(instance.anAfterInit)) return [3 /*break*/, 2];
                        return [4 /*yield*/, instance.anAfterInit(config)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    AnnoBuildStrategy.classAnnations = { "name": "AnnoBuildStrategy", "params": { "build": ["instance", "config", "options"], "beforeInit": ["instance", "config"], "process": ["instance", "config", "options"], "afterInit": ["instance", "config"] } };
    AnnoBuildStrategy = tslib_1.__decorate([
        core_1.Singleton(exports.AnnoBuildStrategyToken)
    ], AnnoBuildStrategy);
    return AnnoBuildStrategy;
}());
exports.AnnoBuildStrategy = AnnoBuildStrategy;

//# sourceMappingURL=../sourcemaps/annotations/AnnoBuildStrategy.js.map
