import { Token, IContainer, Registration, Type, IExports, ParamProviders, ProviderMap } from '@ts-ioc/core';
import { ModuleConfig } from './ModuleConfigure';
/**
 * injected module.
 *
 * @export
 * @class InjectedModule
 * @template T
 */
export declare class InjectedModule<T> implements IExports {
    token: Token<T>;
    config: ModuleConfig<T>;
    container: IContainer;
    type?: Type<any>;
    exports?: Token<any>[];
    constructor(token: Token<T>, config: ModuleConfig<T>, container: IContainer, type?: Type<any>, exports?: Token<any>[]);
    private _map;
    getProviderMap(): ProviderMap;
    resolve<T>(token: Token<T>, ...providers: ParamProviders[]): T;
    hasRegister<T>(key: Token<T>): boolean;
    static classAnnations: any;
}
/**
 * Injected Module Token.
 *
 * @export
 * @class InjectModuleMetaConfigToken
 * @extends {Registration<Type<T>>}
 * @template T
 */
export declare class InjectedModuleToken<T> extends Registration<InjectedModule<T>> {
    constructor(type: Type<T>);
    static classAnnations: any;
}
