import { IService } from './Service';
import { IRunner } from './Runner';
import { RefRegistration, Token } from '@ts-ioc/core';
/**
 * runn able.
 */
export declare type Runnable<T> = IService<T> | IRunner<T>;
/**
 * application runner token.
 *
 * @export
 * @class InjectRunnerToken
 * @extends {Registration<IRunner<T>>}
 * @template T
 */
export declare class InjectRunnableToken<T> extends RefRegistration<Runnable<T>> {
    constructor(type: Token<T>);
    static classAnnations: any;
}
/**
 * default service token.
 */
export declare const ServiceToken: InjectRunnableToken<IService<any>>;
/**
 * default runner token.
 */
export declare const RunnerToken: InjectRunnableToken<IRunner<any>>;
