"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@ts-ioc/core");
/**
 * application runner token.
 *
 * @export
 * @class InjectRunnerToken
 * @extends {Registration<IRunner<T>>}
 * @template T
 */
var InjectRunnableToken = /** @class */ (function (_super) {
    tslib_1.__extends(InjectRunnableToken, _super);
    function InjectRunnableToken(type) {
        return _super.call(this, type, 'Runnable') || this;
    }
    InjectRunnableToken.classAnnations = { "name": "InjectRunnableToken", "params": { "constructor": ["type"] } };
    return InjectRunnableToken;
}(core_1.RefRegistration));
exports.InjectRunnableToken = InjectRunnableToken;
/**
 * default service token.
 */
exports.ServiceToken = new InjectRunnableToken('service');
/**
 * default runner token.
 */
exports.RunnerToken = new InjectRunnableToken('runner');

//# sourceMappingURL=../sourcemaps/runnable/Runnable.js.map
