"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@ts-ioc/core");
/**
 * boot element.
 *
 * @export
 * @abstract
 * @class Boot
 * @implements {IBoot}
 */
var Runner = /** @class */ (function () {
    function Runner(token, instance, config) {
        this.token = token;
        this.instance = instance;
        this.config = config;
    }
    Runner.prototype.getTarget = function () {
        return this.instance;
    };
    Runner.prototype.getTargetToken = function () {
        return this.token || core_1.lang.getClass(this.instance);
    };
    Runner.classAnnations = { "name": "Runner", "params": { "constructor": ["token", "instance", "config"], "getTarget": [], "getTargetToken": [], "run": ["data"] } };
    return Runner;
}());
exports.Runner = Runner;
/**
 * boot element
 *
 * @export
 * @class Boot
 * @extends {Runner<any>}
 */
var Boot = /** @class */ (function (_super) {
    tslib_1.__extends(Boot, _super);
    function Boot(token, instance, config) {
        var _this = _super.call(this, token, instance, config) || this;
        _this.token = token;
        _this.instance = instance;
        _this.config = config;
        return _this;
    }
    Boot.classAnnations = { "name": "Boot", "params": { "constructor": ["token", "instance", "config"] } };
    return Boot;
}(Runner));
exports.Boot = Boot;
/**
 * target is runner or not.
 *
 * @export
 * @param {*} target
 * @returns {target is IRunner<any>}
 */
function isRunner(target) {
    if (target instanceof Runner) {
        return true;
    }
    if (target && core_1.isFunction(target.run)) {
        return true;
    }
    return false;
}
exports.isRunner = isRunner;

//# sourceMappingURL=../sourcemaps/runnable/Runner.js.map
