"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@ts-ioc/core");
/**
 * base service.
 *
 * @export
 * @abstract
 * @class Service
 * @implements {IService}
 */
var Service = /** @class */ (function () {
    function Service(token, instance, config) {
        this.token = token;
        this.instance = instance;
        this.config = config;
    }
    /**
     * get target.
     *
     * @returns {T}
     * @memberof Service
     */
    Service.prototype.getTarget = function () {
        return this.instance;
    };
    Service.prototype.getTargetToken = function () {
        return this.token || core_1.lang.getClass(this.instance);
    };
    Service.classAnnations = { "name": "Service", "params": { "constructor": ["token", "instance", "config"], "getTarget": [], "getTargetToken": [], "start": ["data"], "stop": [] } };
    return Service;
}());
exports.Service = Service;
/**
 * target is service or not.
 *
 * @export
 * @param {*} target
 * @returns {target is IService<any>}
 */
function isService(target) {
    if (target instanceof Service) {
        return true;
    }
    if (target && core_1.isFunction(target.start)) {
        return true;
    }
    return false;
}
exports.isService = isService;

//# sourceMappingURL=../sourcemaps/runnable/Service.js.map
